*****This code detials how to produce Figure 7 in Hambur and La Cava (2018)
*** First portion reads in the bootstrap sample and summarizes
*** Second portion is the code used to bootstrap - note will overwrite existing boostrap sample


*** Read in bootstrap
* Make sure working directory has data file in it
local location ""

*** Read in bootstrap
use "`location'\boots.dta", clear

summarize, detail


/*

*** Code to bootstrap IRF

**Set-up data - 
* Make sure working directory has data file in it
local location ""

* Set to directory with ivreg2 package and rantest package installed
sysdir set PLUS ""

use "`location'\Main_data_file.dta",clear 

gen newid = asxnum

xtset newid year

** Make program to be used in bootstrapping

program xt_irf, rclass

*Regression
xi: xtabond Inv_ppe_st_k l2.lk_ppe l(0/1).d.lrsales l2.lrsales l(1/2).d.lir l3.lir i.year if Inv_ppe_st_k<=Inv_ppe_st_k_p95 & Inv_ppe_st_k>=Inv_ppe_st_k_p5 & year<=2015 & Res!=1, robust

*Make objects
matrix coeffs = e(b)

return scalar inv_1 = coeffs[1,6]
return scalar k_1 = coeffs[1,6]

return scalar inv_2=return(inv_1)*coeffs[1,1]+coeffs[1,7]
return scalar k_2= return(inv_2)+return(inv_1)

return scalar inv_3=return(inv_2)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_1)
return scalar k_3= return(k_2)+return(inv_3)

return scalar inv_4=return(inv_3)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_2)
return scalar k_4= return(k_3)+return(inv_4)

return scalar inv_5=return(inv_4)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_3)
return scalar k_5= return(k_4)+return(inv_5)

return scalar inv_6=return(inv_5)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_4)
return scalar k_6= return(k_5)+return(inv_6)

return scalar inv_7=return(inv_6)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_5)
return scalar k_7= return(k_6)+return(inv_7)

return scalar inv_8=return(inv_7)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_6)
return scalar k_8= return(k_7)+return(inv_8)

return scalar inv_9=return(inv_8)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_7)
return scalar k_9= return(k_8)+return(inv_9)

return scalar inv_10=return(inv_9)*coeffs[1,1]+coeffs[1,8]+coeffs[1,2]*return(k_8)
return scalar k_10= return(k_9)+return(inv_10)

end

bootstrap inv_1=r(inv_1) inv_2=r(inv_2) inv_3=r(inv_3) inv_4=r(inv_4) inv_5=r(inv_5) inv_6=r(inv_6) inv_7=r(inv_7) inv_8=r(inv_8) inv_9=r(inv_9) inv_10=r(inv_10) k_1=r(k_1) k_2=r(k_2) k_3=r(k_3) k_4=r(k_4) k_5=r(k_5) k_6=r(k_6) k_7=r(k_7) k_8=r(k_8) k_9=r(k_9) k_10=r(k_10), rep(1000) saving(boots) seed(451) cluster(asxnum) idcluster(newid) nodrop: xt_irf

use boots,clear

summarize, detail

end
